#include "SocketC.h"

bool SocketC::initSocket()
{
	//ʼ׽ֿ
	WORD w_req = MAKEWORD(2, 2);//汾
	WSADATA wsadata;
	int err;
	err = WSAStartup(w_req, &wsadata);
	if (err != 0)
	{
		return false;
	}
	//汾
	if (LOBYTE(wsadata.wVersion) != 2 || HIBYTE(wsadata.wHighVersion) != 2)
	{
		WSACleanup();
		return false;
	}
	else
	{
		return true;
	}
}

SocketC::~SocketC()
{
	if (state == 1)
	{
		Close();
	}
}

bool SocketC::Connect(string IP, UINT Prot)
{
	if (!initSocket())
	{
		return false;
	}
	struct addrinfo* answer, hint;
	char ipstr[16] = { 0 };
	ZeroMemory(&hint, sizeof(hint));
	hint.ai_family = AF_INET;
	hint.ai_socktype = SOCK_STREAM;

	SOCKADDR_IN server_addr;

	if (getaddrinfo(IP.c_str(), NULL, &hint, &answer) == 0)
	{
		server_addr.sin_family = AF_INET;

		server_addr.sin_addr.S_un.S_addr = ((struct sockaddr_in*)(answer->ai_addr))->sin_addr.S_un.S_addr;
		server_addr.sin_port = htons(Prot);
		((SOCKADDR_IN*)&hint.ai_addr)->sin_port = htons(Prot);


		//׽
		sclient = socket(AF_INET, SOCK_STREAM, 0);
		if (connect(sclient, (SOCKADDR*)&server_addr, sizeof(SOCKADDR)) == SOCKET_ERROR)
		{
			WSACleanup();
			return false;
		}
		else
		{
			state = 1;
			rec = std::thread((&SocketC::Receive), this);
			return true;
		}
	}
	return FALSE;
}

VOID SocketC::Receive()
{
	while(state)
	{
		MsgInfo* info = new MsgInfo;
		info->len = recv(sclient, info->buff, 2047, 0);
		msgLock.lock();
		msgList.push_back(info);
		msgLock.unlock();
	}
	return;
}

int SocketC::Send(const char* Date, int len)
{
	return send(sclient, Date, len, 0);
}

SocketC::MsgInfo* SocketC::GetMsg()
{
	MsgInfo* info = NULL;
	msgLock.lock();
	if (msgList.size() > 0)
	{
		info = *msgList.begin();
		msgList.pop_front();
	}
	msgLock.unlock();
	return info;
}

void SocketC::Close()
{
	state = 0;
	//ر׽
	closesocket(sclient);
	//ͷDLLԴ
	WSACleanup();
	//for (size_t i = 0; i < msgList.size(); i++)
	//{
	//	
	//}
	msgList.clear();
	rec.join();
}
